// Inf2C Computer Systems, Processor design practical
// Copyright 2004-2013, School of Informatics, The University of Edinburgh

#include "systemc.h"
#include "defines.h"
#include "memory.h"
#include <stdio.h>


sc_int<32> memory::addrSel()
{
    // Memory address mutliplexor
    switch(addr_mux.read()){
    case ADDR_PC:
        return pc;
    case ADDR_MAR:
        return mar;
    }
    printf("Memory address mux out of range\n");
    exit(1);
}

void memory::memRd()
{
    while (1) {
        wait(); // wait for any signal on sensitivity list
        wait(2, SC_NS); // delay to produce outputs.

        if (mem_rd) {
            addr = addrSel();
            if ((int) addr < 0 || (int) addr > 1024) {
                printf("Memory read out of range at address %x\n", (int) addr);
                //sc_stop();
            }
            data_out = mem[addr.range(9,2)];
        }
    }
}

void memory::memWr()
{

    if (reset) {

        // LOAD MEMORY
        FILE *fp;
        int i = 0;
        int mem_word;
        char line[256];

        fp = fopen(fname, "r");
        while (fscanf(fp, "%s", line) != EOF) {
            if (line[0] == '%') {
                if (sscanf(line, "%%%x", &mem_word) == 1)
                    mem[i++] = mem_word;
            }
        }
        fclose(fp);
        
    } else if (mem_wrt) {
        
        addr = addrSel();
        if ((int) addr < 0 || (int) addr > 1024) {
            printf("Memory access out of range at address %x\n", (int) addr);
            //sc_stop();
        } else {
            mem[addr.range(9,2)] = data_in;
        }
    }
}

